# Course Manager

## Table of Contents

1. [About the Project](#About-the-Project)
    1. [Demo](#Demo)
    2. [Features](#Features)
    3. [Tech Stack](#Tech-Stack)
    4. [Roadmap](#Roadmap)
2. [Getting Started](#Getting-Started)
3. [Contact](#Contact)

## 📙About the Project

This project is an application created to manage courses and their participants. It
can be useful for all kinds of coaches, instructors and teachers.

Main goals of this project was to practice making full-stack application with React.js and Node.js, and working with
MySQL database.

Front-end repository - https://github.com/madradeus/Course-Manager-front

### 👓Demo

Demo link
![img_1.png](screens/add-new-course.png)
![img_2.png](screens/subscribe.png)
![img_3.png](screens/students-list.png)
![img_4.png](screens/stats.png)
![img_5.png](screens/login-page.png)

### 🎆‍Features

- listing courses with filter,
- single course details,
- creating new course,
- activating/deactivating course,
- listing students with filter,
- single student details,
- creating new students,
- removing students,
- subscribe/unsubscribe,
- stats,
- login/logout,

### 🧑‍💻Tech Stack

- typescript 4.9.5,
- express 4.18.2,
- jsonwebtoken 9.0.0,
- mysql2 3.1.0,
- jest 29.4.2,

### ⏩Roadmap

- attendance list,
- payments monitor & notifications,

## 🚀Getting Started

Clone the project

### `git clone https://github.com/madradeus/Course-Manager-back.git`

Install dependencies

### `npm install`

Start the server development

### `npm start`

Start the watch mode

### `npm run start:dev`

## 🤝Contact

[Mateusz Rodowski](mailto:mateusz.rodowski@gmail.com?subject=[GitHub]) |
mateusz.rodowski@gmail.com