"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const express_1 = __importStar(require("express"));
require("express-async-errors");
const cors_1 = __importDefault(require("cors"));
const errors_1 = require("./utils/errors");
const express_rate_limit_1 = __importDefault(require("express-rate-limit"));
const helmet_1 = __importDefault(require("helmet"));
const cookie_parser_1 = __importDefault(require("cookie-parser"));
const courses_router_1 = require("./routers/courses.router");
const student_router_1 = require("./routers/student.router");
const studentCourse_router_1 = require("./routers/studentCourse.router");
const stats_router_1 = require("./routers/stats.router");
const config_1 = require("./config/config");
const auth_router_1 = require("./routers/auth.router");
const authenticate_1 = require("./utils/middlewares/authenticate");
const app = (0, express_1.default)();
app.use((0, cors_1.default)({
    origin: config_1.config.corsOrigin,
    credentials: true,
}));
app.use((0, express_1.json)({
    limit: "50kb"
}));
app.use((0, cookie_parser_1.default)());
app.use((0, express_rate_limit_1.default)({
    windowMs: 5 * 60 * 1000,
    max: 200, // Limit each IP to 100 requests per `window` (here, per 5 minutes)
}));
app.use((0, helmet_1.default)());
app.use(authenticate_1.authenticate);
app.use('/api/courses', courses_router_1.coursesRouter);
app.use('/api/students', student_router_1.studentRouter);
app.use('/api/studentsCourses', studentCourse_router_1.studentCourseRouter);
app.use('/api/stats', stats_router_1.statsRouter);
app.use('/api/auth', auth_router_1.authRouter);
app.use(errors_1.handleError);
app.listen(3001, '0.0.0.0', () => console.log('listening on http://localhost:3001/'));
//# sourceMappingURL=index.js.map