"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.authRouter = void 0;
const express_1 = require("express");
const Auth_1 = require("../services/Auth");
exports.authRouter = (0, express_1.Router)();
exports.authRouter
    .post('/login', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const user = req.body;
    const accessToken = yield Auth_1.Auth.login(user);
    res
        .cookie('jwt', accessToken, {
        secure: true,
        domain: 'course-manager-m.networkmanager.pl',
        httpOnly: true,
        maxAge: 1000 * 60 * 60,
    })
        .json({
        ok: true
    });
}))
    .get('/logout', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const token = req.cookies.jwt;
    yield Auth_1.Auth.logout(token);
    res
        .clearCookie('jwt', {
        secure: true,
        domain: 'course-manager-m.networkmanager.pl',
        httpOnly: true,
    })
        .json({ ok: true });
}));
//# sourceMappingURL=auth.router.js.map