"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.coursesRouter = void 0;
const express_1 = require("express");
const course_record_1 = require("../records/course.record");
const errors_1 = require("../utils/errors");
const isDate_1 = require("../utils/isDate");
exports.coursesRouter = (0, express_1.Router)();
exports.coursesRouter
    .get('/', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    res.json(yield course_record_1.CourseRecord.getAll());
}))
    .get('/:id', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    res.json(yield course_record_1.CourseRecord.getOne(req.params.id));
}))
    .post('/', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    if (!(0, isDate_1.isDate)(req.body.startDate)) {
        throw new errors_1.ValidationError('Start Date must be a Date type');
    }
    const newCourse = new course_record_1.CourseRecord(Object.assign(Object.assign({}, req.body), { startDate: new Date(req.body.startDate) }));
    if (newCourse.startDate.setHours(0, 0, 0, 0) < new Date().setHours(0, 0, 0, 0)) {
        throw new errors_1.ValidationError('Start date cannot be in past');
    }
    const courseId = yield newCourse.insert();
    res.status(201);
    res.json(courseId);
}))
    .patch('/:id', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const foundCourse = yield course_record_1.CourseRecord.getOne(req.params.id);
    res.json(yield foundCourse.update());
}));
//# sourceMappingURL=courses.router.js.map