"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.studentCourseRouter = void 0;
const express_1 = require("express");
const studentCourse_record_1 = require("../records/studentCourse.record");
exports.studentCourseRouter = (0, express_1.Router)();
exports.studentCourseRouter
    .get('/list-courses/:studentId', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const { studentId } = req.params;
    res.json(yield studentCourse_record_1.StudentCourseRecord.getCoursesOfStudents(studentId));
}))
    .get('/list-students/:courseId', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const { courseId } = req.params;
    res.json(yield studentCourse_record_1.StudentCourseRecord.getParticipantsOfCourse(courseId));
}))
    .delete('/:id', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const { id } = req.params;
    yield studentCourse_record_1.StudentCourseRecord.delete(id);
    res.json({
        status: 'deleted'
    });
}))
    .post('/', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const newStudentCourse = new studentCourse_record_1.StudentCourseRecord(req.body);
    const addedNewStudentCourse = yield newStudentCourse.insert();
    res.status(201);
    res.json(addedNewStudentCourse);
}));
//# sourceMappingURL=studentCourse.router.js.map