"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.defaultStudentCourse = void 0;
const studentCourse_record_1 = require("../../records/studentCourse.record");
const student_record_test_1 = require("../student/student-record.test");
const course_record_test_1 = require("../course/course-record.test");
let courseId;
let studentId;
beforeAll(() => {
    courseId = course_record_test_1.defaultCourse.id;
    studentId = student_record_test_1.defaultStudent.id;
    exports.defaultStudentCourse = new studentCourse_record_1.StudentCourseRecord({
        courseId,
        studentId,
    });
});
test('Can build StudentCourseRecord', () => {
    expect(exports.defaultStudentCourse).toBeDefined();
    expect(exports.defaultStudentCourse.id).toBeUndefined();
    expect(exports.defaultStudentCourse.courseId).toMatch(/^[0-9A-F]{8}-[0-9A-F]{4}-[4][0-9A-F]{3}-[89AB][0-9A-F]{3}-[0-9A-F]{12}$/i);
    expect(exports.defaultStudentCourse.studentId).toMatch(/^[0-9A-F]{8}-[0-9A-F]{4}-[4][0-9A-F]{3}-[89AB][0-9A-F]{3}-[0-9A-F]{12}$/i);
    expect(exports.defaultStudentCourse.courseId).toEqual(course_record_test_1.defaultCourse.id);
    expect(exports.defaultStudentCourse.studentId).toEqual(student_record_test_1.defaultStudent.id);
});
test('Validates invalid courseId', () => {
    expect(() => new studentCourse_record_1.StudentCourseRecord(Object.assign(Object.assign({}, exports.defaultStudentCourse), { courseId: 'abc' }))).toThrow('Wrong studentID or courseId format');
});
test('Validates invalid studentId', () => {
    expect(() => new studentCourse_record_1.StudentCourseRecord(Object.assign(Object.assign({}, exports.defaultStudentCourse), { studentId: 'defg' }))).toThrow('Wrong studentID or courseId format');
});
//# sourceMappingURL=studentCourse-record.test.js.map