"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.authenticate = void 0;
const jsonwebtoken_1 = __importDefault(require("jsonwebtoken"));
const config_1 = require("../../config/config");
const user_record_1 = require("../../records/user.record");
const authenticate = (req, res, next) => __awaiter(void 0, void 0, void 0, function* () {
    if (req.path === '/api/auth/login')
        return next();
    const authorisationToken = req.cookies.jwt;
    if (!authorisationToken)
        return res.sendStatus(403);
    try {
        const payload = yield jsonwebtoken_1.default.verify(authorisationToken, config_1.config.tokenSecret);
        const user = yield user_record_1.UserRecord.getOneById(payload.id);
        if (user.currentToken !== authorisationToken) {
            throw new Error();
        }
    }
    catch (e) {
        return res.sendStatus(403);
    }
    next();
});
exports.authenticate = authenticate;
//# sourceMappingURL=authenticate.js.map